/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.utility;

import java.nio.ByteBuffer;

/**
 *
 * @author Lawal
 */
public class ByteBufferUtility {
    public static final int MEMORY_PAGE_SIZE = 4096;
    
    ByteBuffer buffer;
    public ByteBuffer getBuffer() {
        return buffer;
    }
    void setBuffer(ByteBuffer buffer) {
        this.buffer = buffer;
    }

    public ByteBufferUtility(int capacity) {
        buffer = ByteBuffer.allocate(capacity);
    }

    public byte[] booleanToBytes(boolean val) {
        byte[] result = new byte[1];
        result[0] = (byte)(val ? 1 : 0);
        return result;
    }

    public void addBoolean(boolean val) {
        buffer.put(val ? (byte)1 : (byte)0);
    }

    public boolean getBoolean() {
        return buffer.get() == (byte)1;
    }

    public void addInteger(int val) {
        buffer.putInt(val);
    }

    public int getInteger() {
        return buffer.getInt();
    }

    public void addDouble(double val) {
        buffer.putDouble(val);
    }
    
    public double getDouble() {
        return buffer.getDouble();
    }

    public void addString(String val) {
        for(int i = 0; i < val.length(); i++) {
            buffer.putChar(val.charAt(i));
        }
    }

    public String getString() {
        String result = "" + buffer.getChar() + buffer.getChar() + buffer.getChar() + buffer.getChar() +
                            buffer.getChar() + buffer.getChar() + buffer.getChar() + buffer.getChar() + 
                            buffer.getChar() + buffer.getChar() + buffer.getChar() + buffer.getChar() +
                            buffer.getChar() + buffer.getChar() + buffer.getChar() + buffer.getChar();
        return result;
    }

    public static void main(String[] args) {
    }
}
