/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.utility;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

/**
 *
 * @author Mahmoud
 */
public interface Rankable {
    public List<Double> getSortRank();
    public void setRank(List<Double> sortRank);

    public static void sortAsending(List<Rankable> list) {
            list.sort(new Comparator<Rankable> () {
            @Override
            public int compare(Rankable o1, Rankable o2) {
                
                if(o1.getSortRank().get(0) > o2.getSortRank().get(0)) {
                    return -1;
                } 
                else if(o1.getSortRank().get(0) < o2.getSortRank().get(0)) { 
                    return 1;
                }
                else {
                    return 0;
                }
            }
        });
    }

    public static void sortAsendingAsending(List<Rankable> list) {
            list.sort(new Comparator<Rankable> () {
            @Override
            public int compare(Rankable o1, Rankable o2) {
                
                if(o1.getSortRank().get(0) > o2.getSortRank().get(0)) {
                    return -1;
                } 
                else if(o1.getSortRank().get(0) < o2.getSortRank().get(0)) { 
                    return 1;
                }
                else {
                    if(o1.getSortRank().get(1) > o2.getSortRank().get(1)) {
                        return -1;
                    } 
                    else if(o1.getSortRank().get(1) < o2.getSortRank().get(1)) { 
                        return 1;
                    }
                    else {
                        return 0;
                    }
                }
            }
        });
    }

    public static void sortAsendingAsendingAsending(List<Rankable> list) {
            list.sort(new Comparator<Rankable> () {
            @Override
            public int compare(Rankable o1, Rankable o2) {
                
                if(o1.getSortRank().get(0) > o2.getSortRank().get(0)) {
                    return -1;
                } 
                else if(o1.getSortRank().get(0) < o2.getSortRank().get(0)) { 
                    return 1;
                }
                else {
                    if(o1.getSortRank().get(1) > o2.getSortRank().get(1)) {
                        return -1;
                    } 
                    else if(o1.getSortRank().get(1) < o2.getSortRank().get(1)) { 
                        return 1;
                    }
                    else {
                        if(o1.getSortRank().get(2) > o2.getSortRank().get(2)) {
                            return -1;
                        } 
                        else if(o1.getSortRank().get(2) < o2.getSortRank().get(2)) { 
                            return 1;
                        }
                        else {
                            return 0;
                        }
                    }
                }
            }
        });
    }

    public static void sortDesending(List<Rankable> list) {
            list.sort(new Comparator<Rankable> () {
            @Override
            public int compare(Rankable o1, Rankable o2) {
                
                if(o1.getSortRank().get(0) < o2.getSortRank().get(0)) {
                    return -1;
                } 
                else if(o1.getSortRank().get(0) > o2.getSortRank().get(0)) { 
                    return 1;
                }
                else {
                    return 0;
                }
            }
        });
    }
}
