/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Lawal
 */
public class RQueryResult {
    List<Node> visitedNodes = new ArrayList<>();
    public List<Node> getVisitedNodes() {
        return visitedNodes;
    }
    void setVisitedNodes(List<Node> visitedNodes) {
        this.visitedNodes = visitedNodes;
    }

    List<Node> leaves = new ArrayList<>();
    public List<Node> getLeaves() {
        return leaves;
    }
    void setLeaves(List<Node> leafNodes) {
        this.leaves = leafNodes;
    }
    
    long executionTime;
    public long getExecutionTime() {
        return executionTime;
    }

    void setExecutionTime(long executionTime) {
        this.executionTime = executionTime;
    }

    void appendNodeResult(RQueryResult result) {
        visitedNodes.addAll(result.visitedNodes);
        leaves.addAll(result.leaves);
    }
    
    public void markNodesAsSelected() {
        for(Node leaf:leaves) {
            leaf.getBuilder().setIsSelected(true);
        }
    }

    public void unmarkNodesAsSelected() {
        for(Node leaf:leaves) {
            leaf.getBuilder().setIsSelected(false);
        }
    }
}
