/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.experiment;

import java.io.IOException;
import java.util.Scanner;
import spatial.tree.lab.dataset.SnytheticDataSetGenerator;

/**
 *
 * @author Mahmoud
 */
public class DataSetCreation {
    /**
    *
    * @param args
    */
    public static void main(String[] args) throws IOException, InterruptedException {
        System.out.println("********** Data Set Creation **************\n");
        
        SnytheticDataSetGenerator generator = new SnytheticDataSetGenerator();
        
        Scanner sc = new Scanner(System.in);
        System.out.println("Enter number of dimensions: ");
        int d = sc.nextInt();
        
        System.out.println("Enter number of records: ");
        long n = sc.nextLong();
        
        System.out.println("Enter group percent: ");
        double p = sc.nextDouble();
        
        System.out.println("Enter data type (A, C, E, N): ");
        char c = sc.next().charAt(0);

        String folder = "C:\\PhD\\Results\\";
        String file = folder + 
                        Integer.toString(d) + "_" +
                        Long.toString(n) + "_" +
                        Double.toString(p) + "_" +
                        Integer.toString(d) + 
                        ".dataset";
                
        generator.createDataSet(file, d, n, p, c);
    }
}
