/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.testing;

import java.io.IOException;
import spatial.tree.lab.Node;
import spatial.tree.lab.RPlusTree;

/**
 *
 * @author Lawal
 */
public class TestRPlusTreeCase1 {
    /**
     *
     * @param args
     */
    public static void main(String[] args) throws IOException{
        System.out.println("********** RPlusTree **************\n");

        int dim = 2;
        int m = 2;
        int M = 5;
        int fillFactor = 3;
        RPlusTree rtree = new RPlusTree(null, dim, m, M, fillFactor);
        rtree.setDebugMode(0);

        Node a = rtree.createDataNode().getBuilder().
                                            setId("A").
                                            setInterval(0, 110, 121).
                                            setInterval(1, 45, 56).
                                                    build();
        rtree.InsertData(a);
        rtree.print();
        
        System.out.println("**********************************\n");
        
         
        Node b = rtree.createDataNode().getBuilder().
                                            setId("B").
                                            setInterval(0, 110, 122).
                                            setInterval(1, 45, 60).
                                                    build();
        rtree.InsertData(b);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node c = rtree.createDataNode().getBuilder().
                                            setId("C").
                                            setInterval(0, 110, 123).
                                            setInterval(1, 45, 61).
                                                    build();
        rtree.InsertData(c);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node d = rtree.createDataNode().getBuilder().
                                            setId("D").
                                            setInterval(0, 130, 140).
                                            setInterval(1, 70, 80).
                                                    build();
        rtree.InsertData(d);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node e = rtree.createDataNode().getBuilder().
                                            setId("E").
                                            setInterval(0, 120, 126).
                                            setInterval(1, 45, 63).
                                                    build();
        rtree.InsertData(e);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node f = rtree.createDataNode().getBuilder().
                                            setId("F").
                                            setInterval(0, 110, 130).
                                            setInterval(1, 45, 65).
                                                    build();
        rtree.InsertData(f);
        rtree.print();        
    }
}
