/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.testing;

import java.io.IOException;
import spatial.tree.lab.Node;
import spatial.tree.lab.RPlusTree;
import spatial.tree.lab.RTree;

/**
 *
 * @author Lawal
 */
public class TestRTree {
    /**
     *
     * @param args
     */
    public static void main(String[] args) throws IOException{
        System.out.println("********** RPlusTree **************\n");

        int dim = 5;
        int m = 2;
        int M = 4;
        RTree rtree = new RTree(null, dim, m, M);
        rtree.setDebugMode(1);

        Node a = rtree.createDataNode().getBuilder().
                                            setId("A").
                                            setInterval(0, 110, 120).
                                            setInterval(1, 50).
                                            setInterval(2, 3).
                                            setInterval(3, 46).
                                            setInterval(4, 45, 55).
                                                    build();
        rtree.InsertData(a);
        rtree.print();
        
        System.out.println("**********************************\n");
        
         
        Node b = rtree.createDataNode().getBuilder().
                                            setId("B").
                                            setInterval(0, 120).
                                            setInterval(1, 25).
                                            setInterval(2, 5).
                                            setInterval(3, 53, 67).
                                            setInterval(4, 23, 30).
                                                    build();
        rtree.InsertData(b);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node c = rtree.createDataNode().getBuilder().
                                            setId("C").
                                            setInterval(0, 60, 83).
                                            setInterval(1, 45).
                                            setInterval(2, 3).
                                            setInterval(3, 79).
                                            setInterval(4, 45).
                                                    build();
        rtree.InsertData(c);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node d = rtree.createDataNode().getBuilder().
                                            setId("D").
                                            setInterval(0, 78).
                                            setInterval(1, 105).
                                            setInterval(2, 2).
                                            setInterval(3, 45, 87).
                                            setInterval(4, 120, 130).
                                                    build();
        rtree.InsertData(d);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node e = rtree.createDataNode().getBuilder().
                                            setId("E").
                                            setInterval(0, 100).
                                            setInterval(1, 50).
                                            setInterval(2, 3).
                                            setInterval(3, 64, 86).
                                            setInterval(4, 50).
                                                    build();
        rtree.InsertData(e);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node f = rtree.createDataNode().getBuilder().
                                            setId("F").
                                            setInterval(0, 120, 160).
                                            setInterval(1, 40).
                                            setInterval(2, 4).
                                            setInterval(3, 78).
                                            setInterval(4, 42, 64).
                                                    build();
        rtree.InsertData(f);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node g = rtree.createDataNode().getBuilder().
                                            setId("G").
                                            setInterval(0, 145).
                                            setInterval(1, 40).
                                            setInterval(2, 4).
                                            setInterval(3, 55, 73).
                                            setInterval(4, 40).
                                                    build();
        rtree.InsertData(g);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node h = rtree.createDataNode().getBuilder().
                                            setId("H").
                                            setInterval(0, 85).
                                            setInterval(1, 45).
                                            setInterval(2, 4).
                                            setInterval(3, 66, 89).
                                            setInterval(4, 35, 50).
                                                    build();
        rtree.InsertData(h);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node i = rtree.createDataNode().getBuilder().
                                            setId("I").
                                            setInterval(0, 120).
                                            setInterval(1, 40).
                                            setInterval(2, 4).
                                            setInterval(3, 44, 63).
                                            setInterval(4, 40).
                                                    build();
        rtree.InsertData(i);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node j = rtree.createDataNode().getBuilder().
                                            setId("J").
                                            setInterval(0, 160).
                                            setInterval(1, 45).
                                            setInterval(2, 4).
                                            setInterval(3, 57, 92).
                                            setInterval(4, 40, 45).
                                                    build();
        rtree.InsertData(j);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node k = rtree.createDataNode().getBuilder().
                                            setId("K").
                                            setInterval(0, 130, 140).
                                            setInterval(1, 35).
                                            setInterval(2, 5).
                                            setInterval(3, 45).
                                            setInterval(4, 50).
                                                    build();
        rtree.InsertData(k);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node l = rtree.createDataNode().getBuilder().
                                            setId("L").
                                            setInterval(0, 125, 140).
                                            setInterval(1, 47).
                                            setInterval(2, 3).
                                            setInterval(3, 42, 62).
                                            setInterval(4, 40, 50).
                                                    build();
        rtree.InsertData(l);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node ml = rtree.createDataNode().getBuilder().
                                            setId("M").
                                            setInterval(0, 150).
                                            setInterval(1, 30).
                                            setInterval(2, 4).
                                            setInterval(3, 40, 50).
                                            setInterval(4, 40).
                                                    build();
        rtree.InsertData(ml);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node n = rtree.createDataNode().getBuilder().
                                            setId("N").
                                            setInterval(0, 150, 160).
                                            setInterval(1, 35).
                                            setInterval(2, 3).
                                            setInterval(2, 55, 65).
                                            setInterval(3, 45, 55).
                                                    build();
        rtree.InsertData(n);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node o = rtree.createDataNode().getBuilder().
                                            setId("O").
                                            setInterval(0, 145, 160).
                                            setInterval(1, 40).
                                            setInterval(2, 5).
                                            setInterval(3, 50).
                                            setInterval(4, 45).
                                                    build();
        rtree.InsertData(o);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node p = rtree.createDataNode().getBuilder().
                                            setId("P").
                                            setInterval(0, 115).
                                            setInterval(1, 45).
                                            setInterval(2, 3).
                                            setInterval(3, 43, 57).
                                            setInterval(4, 35, 50).
                                                    build();
        rtree.InsertData(p);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node q = rtree.createDataNode().getBuilder().
                                            setId("Q").
                                            setInterval(0, 130).
                                            setInterval(1, 30).
                                            setInterval(2, 5).
                                            setInterval(3, 47).
                                            setInterval(4, 30, 35).
                                                    build();
        rtree.InsertData(q);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node r = rtree.createDataNode().getBuilder().
                                            setId("R").
                                            setInterval(0, 65, 80).
                                            setInterval(1, 20).
                                            setInterval(2, 3).
                                            setInterval(3, 38).
                                            setInterval(4, 34).
                                                    build();
        rtree.InsertData(r);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node s = rtree.createDataNode().getBuilder().
                                            setId("S").
                                            setInterval(0, 87).
                                            setInterval(1, 67).
                                            setInterval(2, 2).
                                            setInterval(3, 45, 87).
                                            setInterval(4, 100, 120).
                                                    build();
        rtree.InsertData(s);
        rtree.print();
        
        System.out.println("**********************************\n");
        
                
        Node t = rtree.createDataNode().getBuilder().
                                            setId("T").
                                            setInterval(0, 95).
                                            setInterval(1, 73).
                                            setInterval(2, 3).
                                            setInterval(3, 46, 68).
                                            setInterval(4, 42, 64).
                                                    build();
        rtree.InsertData(t);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node u = rtree.createDataNode().getBuilder().
                                            setId("U").
                                            setInterval(0, 130, 140).
                                            setInterval(1, 38).
                                            setInterval(2, 4).
                                            setInterval(3, 87).
                                            setInterval(4, 56).
                                                    build();
        rtree.InsertData(u);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node v = rtree.createDataNode().getBuilder().
                                            setId("V").
                                            setInterval(0, 140).
                                            setInterval(1, 53).
                                            setInterval(2, 4).
                                            setInterval(3, 37, 55).
                                            setInterval(4, 35, 40).
                                                    build();
        rtree.InsertData(v);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node w = rtree.createDataNode().getBuilder().
                                            setId("W").
                                            setInterval(0, 65).
                                            setInterval(1, 89).
                                            setInterval(2, 2).
                                            setInterval(3, 36, 39).
                                            setInterval(4, 50).
                                                    build();
        rtree.InsertData(w);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node x = rtree.createDataNode().getBuilder().
                                            setId("X").
                                            setInterval(0, 102).
                                            setInterval(1, 40).
                                            setInterval(2, 4).
                                            setInterval(3, 34, 44).
                                            setInterval(4, 40, 45).
                                                    build();
        rtree.InsertData(x);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node y = rtree.createDataNode().getBuilder().
                                            setId("y").
                                            setInterval(0, 155).
                                            setInterval(1, 40).
                                            setInterval(2, 3).
                                            setInterval(3, 57, 92).
                                            setInterval(4, 40).
                                                    build();
        rtree.InsertData(y);
        rtree.print();
        
        System.out.println("**********************************\n");
        
        Node z = rtree.createDataNode().getBuilder().
                                            setId("Z").
                                            setInterval(0, 300).
                                            setInterval(1, 25).
                                            setInterval(2, 5).
                                            setInterval(3, 54, 65).
                                            setInterval(4, 34).
                                                    build();
        rtree.InsertData(z);
        rtree.print();
        
        System.out.println("**********************************\n");
        
    }
}
